## hb-ot-shape hb-ot-shape — OpenType shaping support |

## Functions

unsigned int | hb_ot_shape_get_buffer_format_serial ()
void | hb_ot_shape_glyphs_closure ()

## Types and Values

#define | HB_OT_SHAPE_BUFFER_FORMAT_SERIAL

## Includes

    #include <hb-ot.h>

## Description

Support functions for OpenType shaping related queries.

## Functions

### hb_ot_shape_get_buffer_format_serial ()

    unsigned int
    hb_ot_shape_get_buffer_format_serial (void);

Returns the serial number of the current internal buffer format. See HB_OT_SHAPE_BUFFER_FORMAT_SERIAL for more information.

#### Returns

The current buffer-format serial number.

Since: 13.2.0

### hb_ot_shape_glyphs_closure ()

    void
    hb_ot_shape_glyphs_closure (hb_font_t *font,
                                hb_buffer_t *buffer,
                                const hb_feature_t *features,
                                unsigned int num_features,
                                hb_set_t *glyphs);

Computes the transitive closure of glyphs needed for a specified input buffer under the given font and feature list. The closure is computed as a set, not as a list.

#### Parameters

font | hb_font_t to work upon |
buffer | The input buffer to compute from |
features | The features enabled on the buffer. | [array length=num_features]
num_features | The number of features enabled on the buffer |
glyphs | The hb_set_t set of glyphs comprising the transitive closure of the query. | [out]

Since: 0.9.2

## Types and Values

### HB_OT_SHAPE_BUFFER_FORMAT_SERIAL

    #define HB_OT_SHAPE_BUFFER_FORMAT_SERIAL 1

The serial number of the current internal buffer format.

The serial number will increase when internal hb_glyph_info_t and hb_glyph_position_t members change their format.

Since: 13.2.0